c $Id: Drop.f,v 1.6 1995/08/30 10:27:53 zaleski Exp zaleski $
c $Author: zaleski $
c
c
c  A program to start droplets with wind. 
c
c
c
c
      PROGRAM Chute
      include 'undefined.h'
      INTEGER tmax,tmovie,tprint,tsave
      INTEGER t,i,t0
      DOUBLE PRECISION tphys
      INCLUDE 'size.h'
      INCLUDE 'global.f'
      INCLUDE 'pointers.f'
      write(6,*) 
     c "$Id: Drop.f,v 1.6 1995/08/30 10:27:53 zaleski Exp zaleski $"
      call initlog()
c      CALL machineid()
      open(unit=11)
      write(11,*)
     c "$Id: Drop.f,v 1.6 1995/08/30 10:27:53 zaleski Exp zaleski $"

      call read_stdin()
      call initialize(tphys,tmax,tprint,t0)
      call closelog()

      i = ifetch("tsave",tsave)
      i = ifetch("tmovie",tmovie)
      call flush(6)
      do t=t0,tmax
         if(mod(t,tsave).eq.0) then
            call save(u,v,z(icc(ng)),z(iei(ng)),
     $                z(ires(ng)),tau,nx,ny)
	    write (*,*) ' --- Writing dump.dat at t = ',t,' ---'
            call flush(6)
         endif
         call timestep(tphys,t,tprint,tmovie)
      enddo
c
c  Close movie file
c
      close(12)
      STOP
      end

      SUBROUTINE initialize(tphys,tmax,tprint,t0)
      include 'undefined.h'
      INTEGER tmax,tprint,restart,i,t0
      DOUBLE PRECISION tphys
      INCLUDE 'size.h'
      INCLUDE 'global.f'
      INCLUDE 'pointers.f'
      call readglob(tmax,tprint)
           write(6,*) "tauuuu",tau	
      restart=0
      i=ifetch("restart",restart)
      write(6,*) "restart=",restart
      call initpvel(nx,ny)
c
      call printhist(tprint)
      call initpressure(nx,ny)

      if(restart.eq.0) then
	t0=0;
c
c Include here relevant initialisation module
c
c It should be called ini"something". 
c
         tphys=0.0d0
c         call ini1disk(u,v,z(icc(ng)),z(iccol),z(iu(ng)),tau,nx,ny)
c        call ininothing(u,v,z(icc(ng)),z(iu(ng)),tau,nx,ny)
c         call inisquare(u,v,z(icc(ng)),z(iu(ng)),tau,nx,ny)
           write(6,*) "tau=",tau
         call ini1disk(u,v,z(icc(ng)),z(iccol),z(iu(ng)),
     $          xvel,yvel,tau,nx,ny)
c$$$        write(6,*) "x symmetry check for disk initialisation c"
c$$$        call  chkx(cc,nx,ny,0,1)
c$$$        write(6,*) "y symmetry check for disk initialisation c"
c$$$        call  chky(cc,nx,ny,0,1)
         write(6,*) v(12,70)
      else
         call iniget(u,v,z(icc(ng)),z(iu(ng)),nx,ny,t0)
      endif

      call makebccf(z(icc(ng)),nx,ny)
      call makebcf(u,v,nx,ny)

c
c Used in rhouv version
c
c      call acfromcc(z(icc(ng)),z(ia(ng)),z(ic(ng)),
c     %              z(iei(ng)),z(ires(ng)),nx,ny)
c      call rhouv(rhou,rhov,u,v,z(ia(ng)),z(ic(ng)),rhogas,nx,ny)
c      call makebcf(rhou,rhov,nx,ny)

      return
      end


