#include <stdio.h>
#include <stdlib.h>

void datbfile_(double *u, double *v, double *c, double *p, int *nx, int *ny, int *nz, int *t,double *tau)
{
  int i, j, k, nvar = 4;
  float val,tauh;
  char s[256];
  int nb;
  FILE *fptr;

  

  sprintf(s, "%s.%d", "plot.datb",*t);
  fptr = fopen(s, "wb");
  tauh=1./((*tau)*((*nx)-2));
  fwrite(&*nx, sizeof(int), 1, fptr);
  fwrite(&*ny, sizeof(int), 1, fptr);
  fwrite(&*nz, sizeof(int), 1, fptr);
  fwrite(&nvar, sizeof(int), 1, fptr);

  sprintf(s, "u");
  fwrite(s, sizeof(char), 256, fptr);
  sprintf(s, "v");
  fwrite(s, sizeof(char), 256, fptr);
  sprintf(s, "c");
  fwrite(s, sizeof(char), 256, fptr);
  sprintf(s, "p");
  fwrite(s, sizeof(char), 256, fptr);

  for (i = 0; i < *nx; i++)
    for (j = 0; j < *ny; j++)
      for (k = 0; k < *nz; k++) {
        val = tauh*(u[i + (*nx)*j + (*nx)*(*ny)*k]);
        fwrite(&val, sizeof(float), 1, fptr);
      }

  for (i = 0; i < *nx; i++)
    for (j = 0; j < *ny; j++)
      for (k = 0; k < *nz; k++) {
        val = tauh*(v[i + (*nx)*j + (*nx)*(*ny)*k]);
        fwrite(&val, sizeof(float), 1, fptr);
      }

  for (i = 0; i < *nx; i++)
    for (j = 0; j < *ny; j++)
      for (k = 0; k < *nz; k++) {
        val = c[i + (*nx)*j + (*nx)*(*ny)*k];
        fwrite(&val, sizeof(float), 1, fptr);
      }            

  for (i = 0; i < *nx; i++)
    for (j = 0; j < *ny; j++)
      for (k = 0; k < *nz; k++) {
        val = tauh*tauh*p[i + (*nx)*j + (*nx)*(*ny)*k];
        fwrite(&val, sizeof(float), 1, fptr);
      }

  fclose(fptr);
}
