      program test
      IMPLICIT NONE
      integer a,andrew,x,ifetch,dfetch,ffetch
      doubleprecision gp_dfetch
      integer gp_ifetch
      real gp_ffetch
      real b,david
      integer debug,y,z
      doubleprecision c,john,MINFLT,themin
      include 'parinclude.f'

      themin = minflt()

      debug=1

      WRITE(6,*) "_____________________________________________________"
      WRITE(6,*) ""
      WRITE(6,*) "           Testing Fortran         functions         "
      WRITE(6,*) "_____________________________________________________"

      x = ifetch("andrew",a)
      y = ffetch("david",b)
      z = dfetch("john",c)

      if(debug.eq.1) THEN
      write (6,*) "int andrew=",andrew, " read=",a, " err=", x
      write (6,*) "float david=",david, " read=",b, " err=", y
      write (6,*) "double john=",john,  " read=",c, " err=", z
      ENDIF

      if(andrew.ne.a.or.
     $   (abs(david-b)).gt.themin.or.
     $   (abs(john-c)).gt.themin) 
     $    stop 'fgp simple test failed'

      WRITE(6,*) "_____________________________________________________"
      WRITE(6,*) ""
      WRITE(6,*) "           Testing Fortran GP_xxxx functions         "
      WRITE(6,*) "_____________________________________________________"

      debug = GP_ifetch("debug",0,"SEVERE")

      a = GP_ifetch("andrew",0,"DEFAULT")
      b = GP_ffetch("david",345.,"DEFAULT")
      c = GP_dfetch("john",0.D0,"DEFAULT")

      if(debug.eq.2) then
         a = GP_ifetch("andrew",0,"WARNING")
         b = GP_ffetch("david",0.,"WARNING")
         c = GP_dfetch("john",0.D0,"WARNING")

         a = GP_ifetch("noandrew",0,"WARNING")
         b = GP_ffetch("nodavid",345.,"WARNING")
         c = GP_dfetch("nojohn",0.D0,"WARNING")

         a = GP_ifetch("andrew",0,"SEVERE")
         b = GP_ffetch("david",0.,"SEVERE")
         c = GP_dfetch("john",0.D0,"SEVERE")

         a = GP_ifetch("noandrew",0,"SEVERE")
         b = GP_ffetch("nodavid",0.,"SEVERE")
         c = GP_dfetch("nojohn",0.D0,"SEVERE")
      endif

      if(debug.eq.1) THEN
      write (6,*) "int andrew=",andrew, " read=",a, " err=", x
      write (6,*) "float david=",david, " read=",b, " err=", y
      write (6,*) "double john=",john,  " read=",c, " err=", z
      ENDIF

      if(andrew.ne.a.or.
     $   (abs(david-b)).gt.themin.or.
     $   (abs(john-c)).gt.themin) 
     $    stop 'fgp simple test failed'
      
      WRITE(6,*) "*****************************************************"
      WRITE(6,*) "            FORTRAN TEST SUCCESFUL                   "
      WRITE(6,*) "*****************************************************"

      STOP
      END
